import Adw from 'gi://Adw';
import Gio from 'gi://Gio';
import Gtk from 'gi://Gtk';
import GObject from 'gi://GObject';
import { gettext, ExtensionPreferences } from 'resource:///org/gnome/Shell/Extensions/js/extensions/prefs.js';

const KimpanelPrefsWidget = GObject.registerClass(class KimpanelPrefsWidget extends Adw.PreferencesPage {
    settings;
    constructor(settings) {
        super();
        this.settings = settings;
        const miscGroup = new Adw.PreferencesGroup();
        this.add(miscGroup);
        const toggle = new Gtk.Switch({
            action_name: "kimpanel.vertical-list",
            valign: Gtk.Align.CENTER,
        });
        let row = new Adw.ActionRow({
            activatable_widget: toggle,
            title: gettext("Vertical List"),
        });
        this.settings.bind("vertical", toggle, "active", Gio.SettingsBindFlags.DEFAULT);
        row.add_suffix(toggle);
        miscGroup.add(row);
        const button = new Gtk.FontButton();
        row = new Adw.ActionRow({
            activatable_widget: button,
            title: gettext("Font"),
        });
        this.settings.bind("font", button, "font", Gio.SettingsBindFlags.DEFAULT);
        row.add_suffix(button);
        miscGroup.add(row);
    }
});
class KimpanelExtensionPreferences extends ExtensionPreferences {
    getPreferencesWidget() {
        return new KimpanelPrefsWidget(this.getSettings());
    }
}

export { KimpanelExtensionPreferences as default };
